# -*- coding: UTF-8 -*-

import logging
import logging.handlers
import sys, os
import config

class Logger(object):
    uploadDests = []
    unloadDests = []
    dests = []
    location = None

    def __init__(self, location = None):
        if not Logger.location:
            Logger.location = location
            
    def getLogDirectory(self):
        configPath = os.path.normpath(sys.path[0] + "/../config/%s/exchangers.ini" % Logger.location)
        if not config.read(configPath):
            print "Configuration file 'exchangers.ini' not found. %s" % configPath
            exit(1)
        parentDir = config.getString('main', 'logDirectory', '/linuxcash/logs/current')
        if not os.path.exists(parentDir):
            os.makedirs(parentDir)
        return parentDir

    def configureLogger(self, logger, dest):
        parentDir = self.getLogDirectory()
        if Logger.location != 'cs':
            handler = logging.handlers.WatchedFileHandler('%s/%s.log' % (parentDir, dest))
        else:
            handler = logging.handlers.RotatingFileHandler('%s/%s.log' % (parentDir, dest), maxBytes=5000000, backupCount=10, delay=False)
        handler.setFormatter(logging.Formatter('%(asctime)s %(levelname)-8s %(message)s %(module)5s(%(lineno)s)'))
        logger.addHandler(handler)
        logger.setLevel(logging.INFO)
        return logger

    def getLoggerUpload(self, dest):
        dest = 'dictLoad%s' % (dest)
        logger = logging.getLogger('su.artix.%s' % (dest))
        if not dest in Logger.uploadDests:
            logger = self.configureLogger(logger, dest)
            Logger.uploadDests.append(dest)
        return logger

    def getLoggerUnload(self, dest):
        dest = 'saleUnload%s' % (dest)
        logger = logging.getLogger('su.artix.%s' % (dest))
        if not dest in Logger.unloadDests:
            logger = self.configureLogger(logger, dest)
            Logger.unloadDests.append(dest)
        return logger
    
    def getLogger(self, dest, name=None):
        logger = logging.getLogger('%s' % (dest))
        if not name:
            name = dest
        if not dest in Logger.dests:
            logger = self.configureLogger(logger, name)
            Logger.dests.append(dest)
        return logger

