# -*- coding: UTF-8 -*-

import os
import json
from common import logger

class InserterError(Exception):
    """
    Ошибка на уровне передачи данных в Inserter
    """
    pass

class _Inserter(object):
    def __init__(self, node):
        self.node = node
        self.log = logger.Logger().getLoggerUpload(node.id)
        self.objectsCount = 0
        self.startMessageId = ''

    def start(self):
        return True, u'OK'

    def add_package(self, dictObjects):
        return True
    
    def stop(self):
        return True
            
    def saveProgress(self):
        if not os.path.exists("/linuxcash/cash/exchangesystems/progress"):
            return
        data = {"objectsCount": self.objectsCount}
        filePath = "/linuxcash/cash/exchangesystems/progress/counter_%s.json" % self.startMessageId
        with open(filePath, 'w') as outfile:
            json.dump(data, outfile)

    def invalidObjectsCount(self):
        return 0
